<?

/*

 	Webmedia Explorer 5.0 - Multimedia Management System
 	Copyright (C) 2007 Marc Salmurri (marc.salmurri@gmail.com)

 	This program is free software; you can redistribute it and/or modify
 	it under the terms of the GNU General Public License as published by
 	the Free Software Foundation; either version 2 of the License, or (at
 	your option) any later version.

 	This program is distributed in the hope that it will be useful, but
 	WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 	General Public License for more details.

 	You should have received a copy of the GNU General Public License
 	along with this program; if not, write to the Free Software
 	Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.

*/

	function _get_cache_file ( $path, $type, $level = 2 )
	{
		$md5 = md5 ( $path.$type );
		
		$dir = $GLOBALS["path_cache"];
		
		set_dir	( $dir );
		
		for ( $i = 0; $i < $level; $i++ )
		{
			$dir .= $md5[$i]."/";
			
			set_dir	( $dir );
		}

		return $dir.$md5;
	}
			
	function _get_cached ( $path, $type )
	{
		if ( empty ( $path ) ) $path = ".";

		$cache_key 				= md5 ( $type.$path );
		
		if ( isset ( $GLOBALS[$cache_key] ) ) return $GLOBALS[$cache_key];

		$cache_file 			= _get_cache_file ( $path, $type );

		$timestamp 				= @filemtime ( $cache_file );

		$dirstamp 				= @filemtime ( $GLOBALS["home"]."/".$path );

		$diff 					= ( $dirstamp - $timestamp );

		if ( !isset ( $_GET["rebuild"] ) && file_exists ( $cache_file ) && $diff < 0 )
		{
			$data = unserialize ( file_get_contents ( $cache_file ) );

			$GLOBALS[$cache_key] = $data;

			return $data;
		}

		return false;
	}
	
	function _set_cached ( $path, $type, $data )
	{
		if ( empty ( $path ) ) $path = ".";

		$buffer = serialize ( $data );

		$cache_file = _get_cache_file ( $path, $type );

		_file_put_contents ( $cache_file, $buffer );
	}

?>