<?

/*

 	Webmedia Explorer 5.0 - Multimedia Management System
 	Copyright (C) 2007 Marc Salmurri (marc.salmurri@gmail.com)

 	This program is free software; you can redistribute it and/or modify
 	it under the terms of the GNU General Public License as published by
 	the Free Software Foundation; either version 2 of the License, or (at
 	your option) any later version.

 	This program is distributed in the hope that it will be useful, but
 	WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 	General Public License for more details.

 	You should have received a copy of the GNU General Public License
 	along with this program; if not, write to the Free Software
 	Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.

*/

	header ( "Content-type: image/png" );

	include ( "conf/config.lib.php" );

	session_start ();

	include ( $path_include."core.lib.php" );

	$width 		= 260;

	$height 	= 50;

	$img 		= ImageCreateTrueColor ( $width, $height );
	
	$rgb 		= hex2rgb ( $_GET["base_color"] );
	
	$color 		= ImageColorAllocate ( $img, $rgb["r"], $rgb["g"], $rgb["b"] );
		
	ImageFill ( $img, 0, 0, $color );

	$enc = $_SESSION["captcha_code"];

	for ( $i = 0; $i < strlen ( $enc ); $i++ )
	{
		$letter = ImageCreateTrueColor ( $height / 2, $height / 2 );

		$fill_color = ImageColorAllocate ( $letter, $rgb["r"], $rgb["g"], $rgb["b"] );

		ImageFill ( $letter, 0, 0, $fill_color );

		$r_color = mt_rand ( 48, 96 );

		$color = ImageColorAllocate ( $letter, $rgb["r"] + $r_color, $rgb["g"] + $r_color, $rgb["b"] + $r_color );

		ImageString ( $letter, 5, 0, 0, substr ( $enc, $i, 1 ), $color );

		$letter = imageRotate ( $letter, mt_rand ( -10, 10 ), $fill_color );

		imagecopyresampled ( $img, $letter, 15 + $i * 40, 5, 0, 0, $height * mt_rand ( 2, 2.5 ), $height * mt_rand ( 2, 2.5 ), $height, $height );
		
		ImageDestroy ( $letter );	
	}

	for ( $i = 0; $i < $width * 15; $i++ )
	{
		$r_color = mt_rand ( 24, 32 );

		$color = ImageColorAllocate ( $img, $rgb["r"] + $r_color, $rgb["g"] + $r_color, $rgb["b"] + $r_color );

		$x = mt_rand ( 0, $width );

		$y = mt_rand ( 0, $height );

		imageline ( $img, $x, $y, $x + mt_rand ( 0, 1 ), $y + mt_rand ( 0, 1 ), $color );
	}

	ImagePng ( $img );

	ImageDestroy ( $img );

?>