<?

/*

 	Webmedia Explorer 5.0 - Multimedia Management System
 	Copyright (C) 2007 Marc Salmurri (marc.salmurri@gmail.com)

 	This program is free software; you can redistribute it and/or modify
 	it under the terms of the GNU General Public License as published by
 	the Free Software Foundation; either version 2 of the License, or (at
 	your option) any later version.

 	This program is distributed in the hope that it will be useful, but
 	WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 	General Public License for more details.

 	You should have received a copy of the GNU General Public License
 	along with this program; if not, write to the Free Software
 	Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.

*/

class user
{	
	var $rows = 0;
	var $num_rows = 0;
	var $i = 0;

	function user ()
	{
		$this->rows = array ();
	}

	function user_all ()
	{
		$this->rows = $this->_load ();

		$this->num_rows = count ( $this->rows );
	}

	function user_id ( $id_user )
	{
		if ( !is_integer ( (int)$id_user ) ) return false;

		$users = new user ();

		$users->user_all ();

		if ( $users->find_user_by_id ( $id_user ) )
		{
			if ( $users->get () > 0 )
			{
				$row["ip"] 		= $this->get_ip ();

				$this->rows 	= array ();

				$this->rows[0] 	= $users->rows[$users->i];

				$this->num_rows = 1;

				return true;
			}
		}

		return false;
	}

	function user_username_password ( $username, $password )
	{
		if ( empty ( $username ) || ( strlen ( $password ) < 6 ) ) return false;

		$users = new user ();

		$users->user_all ();

		if ( $users->find_user_by_username_password ( $username, $password ) )
		{
			if ( $users->get () > 0 )
			{
				$row["ip"] 		= $this->get_ip ();

				$this->rows 	= array ();

				$this->rows[0] 	= $users->rows[$users->i];

				$this->num_rows = 1;

				return true;
			}
		}

		return false;
	}

	function _load ()
	{
		$dir = $GLOBALS["path_data"];

		set_dir	( $dir );

		$buffer = trim ( file_get_contents ( $GLOBALS["path_data"]."users.txt" ) );

		$_arrays = explode ( "\n", $buffer );

		$rows = array ();

		for ( $i = 0; $i < count ( $_arrays ); $i++ )
		{
			$_array = explode ( ";", $_arrays[$i] );

			$rows[$i]["id_user"] 			= trim ( $_array[0] );
			$rows[$i]["username"] 			= trim ( $_array[1] );
			$rows[$i]["password"] 			= trim ( $_array[2] );
			$rows[$i]["email"] 				= trim ( $_array[3] );
			$rows[$i]["role"] 				= trim ( $_array[4] );
			
			$rows[$i]["width"] 				= trim ( $_array[5] );
			$rows[$i]["language"] 			= trim ( $_array[6] );
			$rows[$i]["fontsize"] 			= trim ( $_array[7] );
			$rows[$i]["sidebar"]			= trim ( $_array[8] );
			$rows[$i]["background"] 		= trim ( $_array[9] );
			$rows[$i]["root_color"] 		= trim ( $_array[10] );
			
			$rows[$i]["view"] 				= trim ( $_array[11] );
			$rows[$i]["num_cols"] 			= trim ( $_array[12] );
			$rows[$i]["num_thumbnails"] 	= trim ( $_array[13] );
		}

		return $rows;
	}

	function _save ()
	{
		$buffer = "";

		$this->num_rows = count ( $this->rows );

		for ( $this->i = 0; $this->i < $this->num_rows; $this->i++ )
		{
			if ( is_array ( $this->rows[$this->i] ) )
			{
				if ( strlen ( $this->get ( "username" ) ) > 0 ) 
				{				
					$buffer .= $this->get ()."; ".$this->get ( "username" )."; ".$this->get ( "password" )."; ".$this->get ( "email" )."; ".$this->get ( "role" );

					$buffer .= "; ".$this->get ( "width" )."; ".$this->get ( "language" )."; ".$this->get ( "fontsize" )."; ".$this->get ( "sidebar" )."; ".$this->get ( "background" )."; ".$this->get ( "root_color" )."; ".$this->get ( "view" )."; ".$this->get ( "num_cols" )."; ".$this->get ( "num_thumbnails" )."\n\r";
				}
			}
		}

		_file_put_contents ( $GLOBALS["path_data"]."users.txt", trim ( $buffer ) );
	}

	function set ( $field, $value ){ $this->rows[$this->i][$field] = $value; }

	function get ( $field = "id_user" ){ return $this->rows[$this->i][$field]; }

	function write ( $field, $value )
	{
		global $lock_file;

		if ( !$this->is_logged () ) return false;

		$fd = fopen ( $GLOBALS["path_data"]."/".$lock_file, "w" );

		if ( flock ( $fd, LOCK_EX ) )
		{
			$users = new user ();

			$users->user_all ();

			$users->find_user_by_username ( $this->get ( "username" ) );

			$this->set ( $field, $value );

			$users->set ( $field, $value );

			$users->_save ();
		}

		fclose ( $fd );

		unlink ( $GLOBALS["path_data"]."/".$lock_file );

		return true;
	}

	function find_user_by_id ( $id_user )
	{
		for ( $this->i = 0; $this->i < $this->num_rows; $this->i++ )
		{
			if ( ( $this->get () == trim ( $id_user ) ) ) return true;
		}

		return false;
	}

	function find_user_by_username ( $username )
	{
		for ( $this->i = 0; $this->i < $this->num_rows; $this->i++ )
		{
			if ( $this->get ( "username" ) == $username ) return true;
		}

		return false;
	}

	function find_user_by_username_password ( $username, $password )
	{
		for ( $this->i = 0; $this->i < $this->num_rows; $this->i++ )
		{
			if ( ( $this->get ( "username" ) == $username ) && ( $this->get ( "password" ) == $password ) ) return true;
		}

		return false;
	}

	function find_user_by_email ( $email )
	{
		for ( $this->i = 0; $this->i < $this->num_rows; $this->i++ )
		{
			if ( ( $this->get ( "email" ) == trim ( $email ) ) ) return true;
		}

		return false;
	}

	function find_max_id ()
	{
		$max_id = 1;

		for ( $this->i = 0; $this->i < $this->num_rows; $this->i++ )
		{
			$id = str_replace ( "-", "", $this->get () );

			if ( $id > $max_id ) $max_id = $id;
		}

		return $max_id;
	}

	function logout ()
	{
		unset ( $_SESSION["username"] );

		session_unregister ( "username" );

		unset ( $_SESSION["password"] );

		session_unregister ( "password" );

		unset ( $_COOKIE["username"] );

		setcookie ( "username", "", -1, $GLOBALS["url_path_base"] );

		unset ( $_COOKIE["password"] );

		setcookie ( "password", "", -1, $GLOBALS["url_path_base"] );

		header ( "location: ".$GLOBALS["url_base"] );

		exit;
	}

	function login ( $data )
	{
		$done = false;
	
		if ( $this->user_username_password ( $data["username"], base64_decode ( $data["password"] ) ) )
		{
			$data["password"] = base64_decode ( $data["password"] );

			$done = true;
		}

		if ( $done || $this->user_username_password ( $data["username"], $data["password"] ) )
		{
			$_SESSION["username"] 	= $data["username"];

			$_SESSION["password"] 	= $data["password"];

			setcookie ( "username", $data["username"], time () + 86400 * 30, $GLOBALS["url_path_base"] );

			$_COOKIE["username"] 	= $data["username"];

			setcookie ( "password", base64_encode ( $data["password"] ), time () + 86400 * 30, $GLOBALS["url_path_base"] );

			$_COOKIE["password"] 	= base64_encode ( $data["password"] );

			header ( "location: ".$GLOBALS["url_base"] );

			exit;
		}
	}

	function activate ( $data )
	{
		global $lock_file;

		$data["password"] = base64_decode ( $data["password"] );

		if ( empty ( $data["username"] ) || ( strlen ( $data["password"] ) < 6 ) ) return false;

		$fd = fopen ( $GLOBALS["path_data"]."/".$lock_file, "w" );

		if ( flock ( $fd, LOCK_EX ) )
		{
			$users = new user ();

			$users->user_all ();

			if ( $users->find_user_by_username_password ( $data["username"], $data["password"] ) )
			{
				if ( ( $users->get () < 0 ) )
				{
					$users->set ( "id_user", str_replace ( "-", "", $users->get () ) );

					$users->_save ();
				}
			}
		}

		fclose ( $fd );

		unlink ( $GLOBALS["path_data"]."/".$lock_file );

		$this->login ( $data );
	}

	function deactivate ( $data )
	{
		global $lock_file;

		$data["password"] = base64_decode ( $data["password"] );

		if ( empty ( $data["username"] ) || ( strlen ( $data["password"] ) < 6 ) ) return false;

		$fd = fopen ( $GLOBALS["path_data"]."/".$lock_file, "w" );

		if ( flock ( $fd, LOCK_EX ) )
		{
			$users = new user ();

			$users->user_all ();

			if ( $users->find_user_by_username_password ( $data["username"], $data["password"] ) )
			{
				$users->set ( "id_user", "-".$users->get () );

				$users->set ( "email", "" );

				$users->_save ();
			}
		}

		fclose ( $fd );

		unlink ( $GLOBALS["path_data"]."/".$lock_file );

		$this->logout ( $data );
	}

	function register ( $data )
	{
		global $lock_file;
		
		$fd = fopen ( $GLOBALS["path_data"]."/".$lock_file, "w" );

		if ( flock ( $fd, LOCK_EX ) )
		{
			$users = new user ();

			$users->user_all ();

			if ( empty ( $data["username"] ) || eregi ( " ", $data["username"] ) ) return 1;

			if ( $users->find_user_by_username ( $data["username"] ) )
			{
				fclose ( $fd );

				unlink ( $GLOBALS["path_data"]."/".$lock_file );

				return 2;
			}

			if ( empty ( $data["email"] ) ) return 3;

			if ( $users->find_user_by_email ( $data["email"] ) )
			{
				fclose ( $fd );

				unlink ( $GLOBALS["path_data"]."/".$lock_file );

				return 4;
			}

			if ( strlen ( $data["password"] ) < 6 ) return 5;

			if ( $data["password"] != $data["password2"] )
			{
				fclose ( $fd );

				unlink ( $GLOBALS["path_data"]."/".$lock_file );

				return 6;
			}

			else
			{
				$max_id = $users->find_max_id ();

				$data["id_user"] = "-".( $max_id + 1 );

				$users->rows[] = $data;

				$users->_save ();

				$headers = "From: ".$GLOBALS["noreplay_from"]."\r\n";

				$buffer = "Hello ".$data["username"].", please confirm your registration by clicking on the following link: \n\r";

				$buffer .= $GLOBALS["weburl"].$GLOBALS["url_base"]."?action=activate&username=".$data["username"]."&password=".base64_encode ( $data["password"] )."\n\r";

				$buffer .= $GLOBALS["webname"]."\n\r";

				mail ( $data["email"], "Confirm registration", $buffer, $headers );

				fclose ( $fd );

				unlink ( $GLOBALS["path_data"]."/".$lock_file );

				header ( "location: ".$GLOBALS["url_base"] );

				exit;
			}
		}
	}

	function unregister ( $data )
	{
		$user = new user ();

		if ( !$user->user_username_password ( $data["username"], $data["password"] ) ) return 1;

		$headers = "From: ".$GLOBALS["noreplay_from"]."\r\n";

		$buffer = "Hello ".$data["username"].", in order to delete your account click on the following link: \n\r";

		$buffer .= $GLOBALS["weburl"].$GLOBALS["url_base"]."?action=deactivate&username=".$data["username"]."&password=".base64_encode ( $data["password"] )."\n\r";

		$buffer .= $GLOBALS["webname"]."\n\r";

		mail ( $user->get ( "email" ), "Confirm unregistration", $buffer, $headers );

		header ( "location: ".$GLOBALS["url_base"] );

		exit;
	}
	
	function remember ( $data )
	{
		$users = new user ();

		$users->user_all ();

		if ( empty ( $data["email"] ) ) return 1;

		if ( !$users->find_user_by_email ( $data["email"] ) ) return 2;

		if ( empty ( $data["captcha_code"] ) ) return 3;

		if ( $_SESSION["captcha_code"] != $data["captcha_code"] ) return 4;

		$headers = "From: ".$GLOBALS["noreplay_from"]."\r\n";

		$buffer = "Hello ".$users->get ( "username" ).", your password is ".$users->get ( "password" )."\n\r";

		$buffer .= "You may login by clicking on the following link: \n\r";

		$buffer .= $GLOBALS["weburl"].$GLOBALS["url_base"]."?action=login&username=".$users->get ( "username" )."&password=".base64_encode ( $users->get ( "password" ) )."\n\r";

		$buffer .= "Feel free to delete your account whenever you please by clicking on the following link: \n\r";

		$buffer .= $GLOBALS["weburl"].$GLOBALS["url_base"]."?action=deactivate&username=".$users->get ( "username" )."&password=".base64_encode ( $users->get ( "password" ) )."\n\r";

		$buffer .= $GLOBALS["webname"]."\n\r";

		mail ( $users->get ( "email" ), "Your password", $buffer, $headers );

		header ( "location: ".$GLOBALS["url_base"] );

		exit;
	}

	function is_logged ()
	{
		if ( $this->get () > 0 ) return true;

		return false;
	}

	function is_admin ()
	{
		if ( $this->get ( "role" ) == "admin" ) return true;

		return false;
	}
	
	function get_ip ()
    {
	    if ( isset ( $_SERVER["HTTP_X_FORWARDED_FOR"] ) )
        {
	        $ip = $_SERVER["HTTP_X_FORWARDED_FOR"];
        }

	    else if ( isset ( $_SERVER["HTTP_CLIENT_IP"] ) )
		{
			$ip = $_SERVER["HTTP_CLIENT_IP"];
		}

	    if ( !isset ( $ip ) || strcmp ( $ip, "127.0.0.1" ) === 0 )
        {
	        $ip = $_SERVER["REMOTE_ADDR"];
        }

	    return (string)$ip;
    }
}

?>